/*
 * fadeSlideShow
 * v.2.2.0
 *
 * Copyright (c) 2010 Pascal Bajorat (http://www.pascal-bajorat.com)
 * Dual licensed under the MIT (below)
 * and GPL (http://www.gnu.org/licenses/gpl.txt) licenses.
 *
 *
 * http://plugins.jquery.com/project/fadeslideshow
 * http://www.pascal-bajorat.com

MIT License

Copyright (c) 2013 Pascal Bajorat

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

jQuery.fn.fredModal = function(options) {
	return this.each(function(){
		fredModalSettings = jQuery.extend({
                        top:40,
                        left:212,
                        width:600,
                        title: null, // default width of the slideshow
                        image: null, // default height of the slideshow
                        content: null,
                        button:{}, //[ class, url image, width, height, link ]
                        modal:true, //modal or not
                        custom:null, //content for custom.. used for help modal
                        closable:true, // closable or not
                        customClass:null,
                        background:null,
                        picto:null
	 	}, options);
                
                //clean existing modal and arrow
                $('.modalArrow').remove();
                $('#modal').empty().hide();
                $('.modal-overlay').remove();
                
		var currentModal = jQuery(this);
                
		// set style for wrapper element
		currentModal.css({
			top: fredModalSettings.top,
			left: fredModalSettings.left,
                        width: fredModalSettings.width,
			position: 'absolute',
                        overflow:'hidden',
                        background: fredModalSettings.background
		});
                
                // add the close button
                if (fredModalSettings.closable) {
                    currentModal.append('<a class="modalCloseImg" title="Close"></a>');
                    jQuery('a.modalCloseImg').bind('click', closeModal);
                }
                
                function closeModal(){
                        currentModal.empty().hide();
                        $('.modalArrow').remove();
                        $('.modal-overlay').remove();
                        if ($.isFunction(fredModalSettings.onClose)) {
				// execute the onOpen callback
				fredModalSettings.onClose.apply(fredModalSettings.onClose, [fredModalSettings.onClose.d]);
			}
                        return false;
                }
                // add the picto
                var pictoSpan = '';
                if (fredModalSettings.picto) pictoSpan='<span id="picto-'+fredModalSettings.picto+'" class="picto"></span>'; 
                // add the title
                if (fredModalSettings.title) currentModal.append('<div class="modalTitle">'+pictoSpan+fredModalSettings.title+'</div>');
                
                var image = '';
                var content = '';
                // add the image
                if (fredModalSettings.image) image = '<img src="'+fredModalSettings.image+'" width="200" height="280" border="0" alt="" />';
                // add the content
                if (fredModalSettings.content) content = '<div class="'+(fredModalSettings.customClass?fredModalSettings.customClass:'modalContent')+'">'+fredModalSettings.content+'</div>';
                if (image!=''){
                    currentModal.append('<div class="modalContent"><div class="modalContentLeft">'+image+'</div><div class="modalContentRight">'+content+'</div></div>');
                } else {
                    currentModal.append('<div class="modalContent">'+content+'</div>');
                }
                

                if (fredModalSettings.button.close!==undefined){
                    currentModal.append('<a href="#" class="modalCloseButton"><div class="modalButton" id="'+fredModalSettings.button.id+'" style="width:'+fredModalSettings.button.width+'px;height:'+fredModalSettings.button.height+'px;background-image:url('+fredModalSettings.button.img+');"></div></a>');
                    jQuery('a.modalCloseButton').bind('click', closeModal);
                }
                
                
                if (fredModalSettings.modal)$('body').append('<div class="modal-overlay"></div>');
                

                
                jQuery(this).show();
                
	});
};